/*
 * 
Spínací hodiny (1 režim) 00:00 - 23:59
Verze 1.4

Přidáno:
 - Při otevřeném nastavovacím menu a případné nečinnosti (delší než 1 minuta)se vše vrátí do zobrazení času (BACK)
 - Ukládání spínacího/vypínacího času do EEPROM paměti - nastavení si budou hodiny pamatovat i po výpadku napájení ;)
 - Opravena možnost nastavení stejného zap. a vyp. času, nyní už to není možné
 - Hodiny nyní mohou spínat i přes noc (např od 22:15 a vypnout např v 6:20)
 
Vytvořil: Vilfein
v.khun@seznam.cz

NÁVOD: 
 * Čas hodin nastavíte současným stisknutím tlačítek "tlacUp" a "tlacDown" po dobu 1 sekundy (1. Hodiny/ 2. Minuty/ 3. Den/ 4. Měsíc/ 5. Rok),
   každý přechod menu potvrdíte stisknutím a současným přidržením tlačítek "tlacUp" a "tlacDown". Čas jednotlivých menu nastavujete tlačítky "tlacUp" (+)
   a "tlacDown"(-). Nastavenou hodnotu potvrdíte stiskem a přidržením po dobu 1 sekundy, čímž přejdete do dalšího menu.
 * Chcete-li vypnout/zapnout podsvícení LCD displaye, stiskněte současně na 1 sekundu tlačítka "tlacUp" a "info" (rozsvícení) nebo "tlacDown" a "info" (zhasnutí).
 * Tlačítko Info přepíná mezi režimem "Hodiny" a "Spínací Hodiny".
 * Chcete-li nastavit spínací a vypínací čas, přejděte do menu "Spínací Hodiny" a  stisknutím a přidržením tlačítek "tlacUp" a "tlacDown" 
   ovládejte nastavovací menu.
 * Není možné nastavit stejný zapínací a vypínací čas!
 * Pro vypnutí časování nastavte spínací čas na 24hod!
 
*/
// -----------------------------------------------------------------připojení knihoven
#include <EEPROM.h>
#include <Wire.h>
#include "RTClib.h"
#include <LiquidCrystal_I2C.h>
//------------------------------------------------------------------
//Iniciace LCD displaye přes I2C sběrnici a upřesnění adresy
LiquidCrystal_I2C lcd(0x27,16,2);
//------------------------------------------------------------------
//Vytvoření proměnných pro tlačítka a hodiny
int tlacUp = 3;
int tlacDown = 4;
int mode = 0;
int OUT= 12;// deklarace výstupu (pro změnu výstupního pinu změnte číslo 13 na číslo NEOBSAZENÉHO digitálního výstupu
boolean svit = false;
int tlacInfo = 5;
int spinacMode = 0;
int ZapnoutSpinac = 0;
int hodZap = 24;
int minZap = 0;
int info = 0;
int hodVyp = 0;
int minVyp = 0;

int hod;
int minut;
int den = 1; // nastavení na 1. aby v nastavení nebyly po prvním spuštění nuly
int mes = 1; // nastavení na 1. aby v nastavení nebyly po prvním spuštění nuly
int rok = 2018; // nastavení na 2018 aby v nastavení nebyly po prvním spuštění nuly
//-----------------------------------------------------------------
// vytvoření instance DS3231 z knihovny RTClib
RTC_DS1307 DS3231;

// vytvoření pole DnyVTydnu s názvy jednotlivých dní
char DnyVTydnu[7][8] = {"Nedele", "Pondeli", " Utery  ", "Streda ", "Ctvrtek", " Patek  ", "Sobota "};// den nesmí začínat znakem s diakritikou!
// DNY MUSÍ BÝT BEZ DIAKRITIKY!!! Jinak LCD vykresluje nevyžádané symboly

//-----------------------------------------------------------------------------------Ovládání času pro funkci BACK
unsigned long doba = 60000;
unsigned long tedMillis = 0;

void setup () {
    
  lcd.init();
  lcd.backlight();
  lcd.clear();
  lcd.setCursor(0,0);//---------------------------------------------Nastavení zobrazení "Načítám čas..."
  lcd.print("Nacitam cas");
  delay(400);
  lcd.print(".");
  delay(400);
  lcd.print(".");
  delay(400);
  lcd.print(".");
  delay(400);
  lcd.setCursor(6,1);
  lcd.print("OK");
  delay(400);
  lcd.clear();
    
 /*!!!!! 
  *  funkce DS3231.adjust() slouží pro jednorázové nastavení času např. při prvním testu programu
  NUTNÉ ODSTRANIT ZPĚTNÁ LOMÍTKA A NÁSLEDNĚ PO ODESLÁNÍ DO ARDUINA OPĚT ZAKOMENTOVAT A ZNOVU ODESLAT!!!!!
  Poté již můžeme měnit čas pomocí tlačítek :) */
   //DS3231.adjust(DateTime(rok, mes, den, hod, minut, 1));

// deklarace tlačítek a výstupů
  pinMode(tlacUp, INPUT_PULLUP);
  pinMode(tlacDown, INPUT_PULLUP);
  pinMode(OUT,OUTPUT);
  pinMode(tlacInfo, INPUT_PULLUP);

// načtení posledních uložených hodnot z EEPROM paměti
hodZap = EEPROM.read(1);// adresa hodZap je (1)
minZap = EEPROM.read(2);// adresa minZap je (2)
hodVyp = EEPROM.read(3);// adresa hodVyp je (3)
minVyp = EEPROM.read(4);// adresa minVyp je (4)
svit = EEPROM.read(7);
}

void hodiny() {// --------------------------------------------------funkce zobrazování času

   DateTime datumCas = DS3231.now();
  //zobrazení informací na LCD
  //----------------------------------------HODINY;
  lcd.setCursor(0,0);
  lcd.print(" ");
  lcd.setCursor(1,0);
  if (datumCas.hour()<10){ // když bude hodina menší než 10, přidej před ni nulu
    lcd.print("0");
  lcd.print(datumCas.hour());}
  else{lcd.setCursor(1,0);
  lcd.print(datumCas.hour());}
  //---------------------------------------MINUTY
  lcd.setCursor(3,0);
  lcd.print(':');
  if (datumCas.minute()<10){
    lcd.setCursor(4,0);
    lcd.print("0");
    lcd.setCursor(5,0);
    lcd.print(datumCas.minute());}
  else {lcd.setCursor(4,0);
  lcd.print(datumCas.minute());}
  //------------------------------------------DEN V TÝDNU (JMÉNO)
  lcd.print("  ");
  lcd.print(DnyVTydnu[datumCas.dayOfTheWeek()]);
  lcd.print("  ");
  lcd.setCursor(0,1);
  lcd.print("   ");
  //--------------------------------------------DEN
  if (datumCas.day()<10){
  lcd.setCursor(3,1);
  lcd.print("0");
  lcd.print(datumCas.day());}
  else {lcd.setCursor(3,1);
  lcd.print(datumCas.day());}
  //---------------------------------------------MĚSÍC
  lcd.setCursor(5,1);
  lcd.print('.');
  if (datumCas.month()<10){
    lcd.setCursor(6,1);
    lcd.print("0");
    lcd.setCursor(7,1);
    lcd.print(datumCas.month());}
  else {lcd.setCursor(6,1);}
   lcd.print(datumCas.month());
  lcd.setCursor(8,1);
  lcd.print('.');
  //-----------------------------------------------ROK
  lcd.setCursor(9,1);
  lcd.print(datumCas.year());
  lcd.print("   ");
  delay(100);
}
//------------------------------------------------------------------------------------------------


//------------------------------------------------------------------------------------FUNKCE NASTAVENÍ ČASU MANUÁLNĚ

void nastavCasRok() { // funkce pro nastavení či změnu roku
  
  lcd.setCursor(0,0);
  lcd.print("Nastav Rok:     ");
  lcd.setCursor(0,1);
  lcd.print(rok);
  lcd.print("            ");
  delay(100);
  if ((digitalRead(tlacUp))==LOW) {
delay(150);
rok++;
}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
rok--;
}

if (rok<2018) {rok=2018;}
if (rok>2090) {rok=2090;}

  }
void nastavCasDen() { // funkce pro nastavení či změnu dne
  
  lcd.setCursor(0,0);
  lcd.print("Nastav Den:     ");
  lcd.setCursor(0,1);
  if (den<10) {lcd.print("0");}
  lcd.print(den);
  lcd.print("              ");
  delay(100);
if ((digitalRead(tlacUp))==LOW) {
delay(150);
den++;
}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
den--;
}

if (den<1) {den=31;}
if (den>31) {den=1;}

}
void nastavCasMesic() { // funkce pro nastavení či změnu měsíce
  
  lcd.setCursor(0,0);
  lcd.print("Nastav Mesic:");
  lcd.setCursor(0,1);
  if (mes<10){lcd.print("0");}
  lcd.print(mes);
  lcd.print("              ");
  delay(100);
  
 if ((digitalRead(tlacUp))==LOW) {
delay(150);
mes++;
}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
mes--;
}

if (mes<1) {mes=12;}
if (mes>12) {mes=1;}

  
  }  
void nastavCasHodiny(){ // funkce pro nastavení či změnu hodin

lcd.setCursor(0,0);
lcd.print("Nastav Hodiny:  ");
lcd.setCursor(0,1);
if (hod<10) {lcd.print("0");}
lcd.print(hod);
lcd.print(":             ");
delay(100);
if ((digitalRead(tlacUp))==LOW) {
delay(150);
hod++;
hod = hod;}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
hod--;
}
if (hod<0) {hod=23;}
if (hod>23) {hod=0;}
}
void nastavCasMinuty(){// funkce pro nastavení či změnu minut
  
  lcd.setCursor(0,0);
  lcd.print("Nastav Minuty:  ");
  lcd.setCursor(0,1);
  if(hod<10) {lcd.print("0");}
  lcd.print(hod);
  lcd.print(":");
  if (minut<10) {lcd.print("0");}
  lcd.print(minut);
  lcd.print("                ");
delay(100);
if ((digitalRead(tlacUp))==LOW) {
delay(150);
minut++;}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
minut--;
}
if (minut<0) {minut=59;}
if (minut>59) {minut=0;}

}
void nastavVse()// funkce pro uložení a aktualizaci ručně zadaných dat
{lcd.clear();
lcd.setCursor(2,0);
lcd.print("NASTAVENO :)");
delay(900);
DS3231.adjust(DateTime(rok, mes, den, hod, minut, 1));
mode++;
lcd.clear();}

//---------------------------------------------------------

//---------------FUNKCE SPÍNÁNÍ---------------------------------

void zapnoutHod(){// -----------------------------------------------funkce pro ruční nastavení doby zapnutí(HODINY)
DateTime datumCas = DS3231.now();

lcd.setCursor(0,0);
lcd.print("Zapnout v:hodiny");
lcd.setCursor(0,1);
 if (hodZap<10)
 {lcd.print("0");
  lcd.print(hodZap);}
  else{lcd.setCursor(0,1);
  lcd.print(hodZap);}
  
lcd.print(":");
if (minZap<10){
    lcd.print("0");
  lcd.print(minZap);}
  else{lcd.setCursor(3,1);
  lcd.print(minZap);
  }
  if (hodZap == 24){lcd.print(" VYPNUTO!  ");}// pokud je hodnota hodin 24 napiš VYPNUTO
else{lcd.print("             ");}
delay(100);
if ((digitalRead(tlacUp))==LOW) {
delay(150);
hodZap++;}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
hodZap--;
}
if (hodZap<0) {hodZap=24;}
if (hodZap>24) {hodZap=0;}

}


void zapnoutMin(){// --------------------------------------funkce pro ruční nastavení doby zapnutí(MINUTY)
  DateTime datumCas = DS3231.now();
lcd.setCursor(0,0);
lcd.print("Zapnout v:minuty");
lcd.setCursor(0,1);
if (hodZap<10){
    lcd.print("0");
  lcd.print(hodZap);}
  else{lcd.setCursor(0,1);
  lcd.print(hodZap);}
lcd.print(hodZap);
lcd.setCursor(2,1);
lcd.print(":");
if (minZap<10){
    lcd.print("0");
  lcd.print(minZap);}
  else{lcd.setCursor(3,1);
  lcd.print(minZap);}
if (hodZap == 24){lcd.print(" VYPNUTO!  ");}// pokud je hodnota hodin 24 napiš VYPNUTO
else{lcd.print("             ");}
delay(100);

if ((digitalRead(tlacUp))==LOW) {
delay(150);
minZap++;
}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
minZap--;
}
if (minZap<0) {minZap=59;}
if (minZap>59) {minZap=0;}
}

void vypnoutHod(){// ----------------------------------------------funkce pro ruční nastavení doby vypnutí(HODINY)
  DateTime datumCas = DS3231.now();

lcd.setCursor(0,0);
lcd.print("Vypnout v:hodiny");
lcd.setCursor(0,1);
if (hodVyp<10){
    lcd.print("0");
  lcd.print(hodVyp);}
  else{lcd.setCursor(0,1);
  lcd.print(hodVyp);}
  
lcd.print(":");
if (minVyp<10){
    lcd.print("0");
  lcd.print(minVyp);
  }
  else{lcd.setCursor(3,1);
  lcd.print(minVyp);
  }
  delay(100);
if ((digitalRead(tlacUp))==LOW) {
delay(150);

hodVyp++;
}
 if (hodZap == 24){lcd.print(" VYPNUTO!  ");}// pokud je hodnota hodin 24 napiš VYPNUTO
else{lcd.print("             ");}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
hodVyp--;
}
if (hodVyp<0) {hodVyp=23;}
if (hodVyp>23) {hodVyp=0;}
}

void vypnoutMin () {// --------------------------------funkce pro ruční nastavení doby vypnutí(MINUTY)
  DateTime datumCas = DS3231.now();
lcd.setCursor(0,0);
lcd.print("Vypnout v:minuty");
lcd.setCursor(0,1);
if (hodVyp<10){
    lcd.print("0");
  lcd.print(hodVyp);}
  else{lcd.setCursor(0,1);
  lcd.print(hodVyp);}
lcd.print(hodVyp);
lcd.setCursor(2,1);
lcd.print(":");
if (minVyp<10){
    lcd.print("0");
  lcd.print(minVyp);}
  else{lcd.setCursor(3,1);
  lcd.print(minVyp);}
if (hodZap == 24){lcd.print(" VYPNUTO!  ");}// pokud je hodnota hodin 24 napiš VYPNUTO
else{lcd.print("             ");}
delay(100);

if ((digitalRead(tlacUp))==LOW) {
delay(150);
minVyp++;}

if ((digitalRead(tlacDown))==LOW) {
delay(150);
minVyp--;}

if (minVyp<0) {minVyp=59;}
if (minVyp>59) {minVyp=0;}
}
//------------------------------------------------Funkce pro potvrzení nastavení spínacích hodin
void setSpinac(){
 if ((hodZap == hodVyp) && (minZap == minVyp)) {
 lcd.clear();
 lcd.print("CASY JSOU STEJNE!");// upozornění na stejné vyp/zap časy
 delay(800);
  spinacMode = 4;}
  else {  
    // Uložení nově nastavených hodnot do EEPROM paměti
    EEPROM.update(1,hodZap);
    EEPROM.update(2,minZap);
    EEPROM.update(3,hodVyp);
    EEPROM.update(4,minVyp);
lcd.clear();
lcd.print("  NASTAVENO ;)  ");// potvrzení správného nastavení  a jeho uložení 
delay(800);
spinacMode = 0;}
}

void ukazCas(){// -----------------------------------------------------------funkce pro zobrazování času (hodiny)
  if (((digitalRead(tlacUp))==LOW)&&((digitalRead(tlacDown))==LOW)) {
  delay(400);
tedMillis = millis();
   mode++;}
 
if (mode > 6) mode = 0;
  
  if (mode == 0)hodiny();// funkce zobrazení hodin
  if (mode == 1) {nastavCasHodiny();} //volání funkce nastavení hodin
  if (mode == 2) {nastavCasMinuty();}// volání funkce nastavení minut
  if (mode == 3) {nastavCasDen();}// volání funkce nastavení dne
  if (mode == 4) nastavCasMesic();// volání funkce nastavení měsíce
  if (mode == 5) nastavCasRok();// volání funkce nastavení roku
  if (mode == 6) nastavVse();}

  void spinac(){//-----------------------------------------------------------------funkce pro přepínání režimů spínacích hodin
  
DateTime datumCas = DS3231.now();
if (((digitalRead(tlacDown)) == LOW)&&((digitalRead(tlacUp))==LOW)) {spinacMode++; tedMillis = millis();
delay(500);
if (spinacMode>5) spinacMode = 0;}
  
  
  if (spinacMode == 1) zapnoutHod();// nastavení hodiny sepnutí
  if (spinacMode == 2) zapnoutMin();//nastavení minuty sepnutí
  if (spinacMode == 3) vypnoutHod();//nastavení hodiny vypnutí
  if (spinacMode == 4) vypnoutMin();//nastavení minuty vypnutí
  if (spinacMode == 5) setSpinac();
  if (spinacMode == 0) {// zobrazení spínací a vypínací doby
  
  lcd.setCursor(0,0);
  lcd.print("Zapnu v: ");
  if (hodZap<10){lcd.print("0");}
  lcd.print(hodZap);
  if (hodZap == 24){
    digitalWrite(OUT,LOW);
  lcd.setCursor(0,0);
  lcd.print("    VYPNUTO     ");// je-li nastaveno vypnutí, zobrazí VYPNUTO
  lcd.setCursor(0,1);
  lcd.print("----------------");
  
  delay(200);}
  else{
  lcd.print(":");
  if(minZap<10){lcd.print("0");}
  lcd.print(minZap);
  lcd.print("  ");
  lcd.setCursor(0,1);
  lcd.print("Vypnu v: ");
    if (hodVyp<10){lcd.print("0");}
  lcd.print(hodVyp);
  lcd.print(":");
   if(minVyp<10){lcd.print("0");}
  lcd.print(minVyp);
   lcd.print("  ");
  delay(300);
  }
  }
    }

void loop () {
if (svit == 0) lcd.noBacklight();
if (svit==1) lcd.backlight();

 DateTime datumCas = DS3231.now();

 
  if (hodZap < hodVyp){
  if (datumCas.hour() >= hodZap && datumCas.minute()>=minZap)
  {digitalWrite(OUT,HIGH);}//---------------------------------------------------Podmínka pro sepnutí spínacích hodin
  else if (hodZap == 24){digitalWrite(OUT,LOW);}
  if (datumCas.hour() >= hodVyp && datumCas.minute()>=minVyp)
  {digitalWrite(OUT,LOW);}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin

  if (hodZap > hodVyp){
  if (datumCas.hour() >= hodZap && datumCas.minute()>=minZap && datumCas.hour() <=23)
  {digitalWrite(OUT,HIGH);}//---------------------------------------------------Podmínka pro sepnutí spínacích hodin
  else if (hodZap == 24){digitalWrite(OUT,LOW);}
  else if (datumCas.hour() < hodVyp)
  {digitalWrite(OUT,HIGH);}
  else if (datumCas.hour() >= hodVyp && datumCas.minute() >= minVyp && datumCas.hour() < hodZap){digitalWrite(OUT,LOW);}}

  if (hodZap == hodVyp){
    if (datumCas.hour() >= hodZap && datumCas.minute()>=minZap)
  {digitalWrite(OUT,HIGH);}//---------------------------------------------------Podmínka pro sepnutí spínacích hodin
  else if (hodZap == 24){digitalWrite(OUT,LOW);}
  if (datumCas.hour() >= hodVyp && datumCas.minute()>=minVyp)
  {digitalWrite(OUT,LOW);}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin
  
 if (digitalRead(tlacInfo)==LOW){
  tedMillis = millis();
  info++;
  delay(220);
  
  if (info>1) info =0;}
   if ((millis()- tedMillis) > doba){//---------------------------------------Podmínka pro návrat zobrazení času po nečinnosti
    
    info = 0;
    spinacMode = 0;
    mode = 0;}
  
  if (info == 0)ukazCas();
  if (info == 1) spinac();
  
  // pokud by někde nebylo žádoucí osvětlení dosplaye, lze ho vypnout, případně zapnout - bude svítit trvale, dokud stav nezměníme
if ((digitalRead(tlacUp)==LOW)&&(digitalRead(tlacInfo)==LOW))// zapnutí podsvícení
{delay(1000);
svit = 1;
EEPROM.update(7,svit);
delay(200);
}
if ((digitalRead(tlacDown)==LOW) &&(digitalRead(tlacInfo)==LOW))// vypnutí podsvícení
{delay(1000);
svit = 0;
EEPROM.update(7,svit);
delay(200);
}
}
